#include <Arduino.h>
#include <U8g2lib.h>
#include <SPI.h>
#include <Wire.h>
#include "pin_map.h"
#include <Thermistor.h>
#include <NTC_Thermistor.h>
#include <RunningMedian.h>
#include <ClickEncoder.h>
// #include <Encoder.h>
#include <TimerOne.h>

// Thermistor
#define SENSOR_PIN             TEMP_0_PIN
#define REFERENCE_RESISTANCE   8000
#define NOMINAL_RESISTANCE     100000
#define NOMINAL_TEMPERATURE    25
#define B_VALUE                3950
#define STM32_ANALOG_RESOLUTION 4095

// LED Screen
U8G2_ST7920_128X64_1_SW_SPI u8g2(U8G2_R0, DOGLCD_SCK , DOGLCD_MOSI, DOGLCD_CS );
// U8G2_UC1701_MINI12864_1_3W_SW_SPI

#define _width 128
#define _height 64
static const uint8_t _bits[] PROGMEM = {
 0x00,0x00,0x00,0x00,0x01,0x00,0x00,0x80,0x01,0x00,0x00,0x80,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x02,0x00,0x00,0x80,0x01,0x00,0x00,0x40,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x00,0x40,0x02,0x00,0x00,0x20,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x00,0x40,0x02,0x00,0x00,0x10,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x00,0x00,0x20,0x04,0x00,0x00,
 0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x00,0x00,0x20,0x04,0x00,
 0x00,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,0x00,0xf0,0x0f,
 0x00,0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x00,0x00,0xf0,
 0x0f,0x00,0x00,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00,
 0xe8,0x17,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,
 0x00,0xe8,0x17,0x00,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x04,0x00,0xe4,0x27,0x00,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x08,0x00,0xe4,0x27,0x00,0x10,0x60,0x0c,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x10,0x00,0xe2,0x47,0x00,0x08,0x10,0x10,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x20,0x00,0xe2,0x47,0x00,0x04,0x10,0x10,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x40,0x00,0xe1,0x87,0x00,0x02,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x80,0x00,0xe1,0x87,0x00,0x01,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xff,0xff,0x80,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0xc0,0x03,0x40,0x00,0x10,0x10,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x80,0x01,0x20,0x00,0x10,
 0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x80,0x01,0x10,0x00,
 0x60,0x0c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x80,0x01,0x08,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x80,0x01,
 0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x40,
 0x03,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,
 0xde,0x7a,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0xf0,0x0f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x20,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x20,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x20,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x20,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x04,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x04,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xd0,0x0f,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf0,0xdb,0x0f,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,0xd8,0x0f,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xf0,0x0f,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xc0,0x00,0xf0,
 0x0f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x00,
 0x20,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x10,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x08,0x00,0xd0,0x0f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x04,0x00,0xd0,0x0f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x02,0xf0,0xdb,0x0f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x01,0x0c,0xf8,0x0f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0xc0,0x00,0x03,0xf0,0x0f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x30,0xc0,0x00,0x20,0x04,0x00,0x00,0x00,0x00,0x00,0x00,
 0xfe,0x00,0x00,0x00,0x00,0x0e,0x20,0x00,0x20,0x04,0x00,0x00,0x00,0x00,0x00,
 0xc0,0xff,0x00,0x00,0x80,0xff,0x01,0x10,0x00,0xf0,0x0f,0x00,0x00,0x00,0x00,
 0x00,0xe0,0xff,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0xf0,0x0f,0x00,0x00,0x00,
 0x00,0x00,0xf8,0xff,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0xf0,0x0f,0x00,0x00,
 0x00,0x00,0x00,0xfc,0xff,0x00,0x00,0x00,0x00,0x00,0x02,0x00,0xf0,0x0f,0x00,
 0x00,0x00,0x00,0x00,0xfe,0xff,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0xe0,0x07,
 0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x00,0x00,0x00,0x00,0xc0,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xfc,0x00,0x00,0x00,0x00,0x30,0x00,0x00,
 0x80,0x01,0x00,0x00,0x00,0x00,0x80,0x9f,0xe4,0x00,0x00,0x00,0x00,0x0e,0x00,
 0x00,0xc0,0x03,0x00,0x00,0x00,0x00,0xc0,0x1f,0xe0,0x00,0x00,0x80,0xff,0x01,
 0x00,0x00,0xc0,0x03,0x00,0x00,0x00,0x00,0xc0,0x3f,0xf0,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xc0,0x0f,0xc3,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0xe0,0x0f,0xc3,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x00,0x00,0x00,0xe0,0x3f,0xf0,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0xe0,0x1f,0xe0,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x00,0x00,0x00,0xe0,0x9f,
 0xe4,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0xe0,
 0xff,0xfc,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x00,0x00,0x00,
 0xe0,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x00,
 0x00,0xe0,0xff,0xff };


Thermistor* upper_thermistor;
RunningMedian t0_samples = RunningMedian(100);
Thermistor* lower_thermistor;
RunningMedian t2_samples = RunningMedian(100);
// What degree celcius to attempt to stabilize at each thermistor
double heat_target[2];
// Degrees celcius change per second
double heat_velocity[2];
long last, value;
unsigned int sensorReadFreq = 1; // Hz

// Rotary encoder input on ST7920 controller, (typically included in LCD 12864)
// https://reprap.org/wiki/File:Reprap_fgdc_smart_adapter_pinout.png

ClickEncoder* encoder;

void read_input()
{
  encoder->service();
  value += encoder->getValue();
}

void setup(void) {
  Serial.begin(9600);

  Timer1.initialize(1000);
  Timer1.attachInterrupt(read_input);

  encoder = new ClickEncoder(D31, D33, D35);
  // encoder->setAccelerationEnabled(true);
  last = -1;

  // Rotary encoder btns
  // pinMode(BTN_EN1, INPUT_PULLUP);
  // pinMode(BTN_EN1, INPUT);
  // pinMode(BTN_EN2, INPUT);
  // pinMode(BTN_ENC, INPUT);

  // Thermistors
  pinMode(40, OUTPUT);
  pinMode(42, OUTPUT);

  heat_target[0] = 240.0;
  heat_target[1] = 240.0;
  u8g2.begin();
  upper_thermistor = new NTC_Thermistor(
    SENSOR_PIN,
    REFERENCE_RESISTANCE,
    NOMINAL_RESISTANCE,
    NOMINAL_TEMPERATURE,
    B_VALUE
  );
  lower_thermistor = new NTC_Thermistor(
    TEMP_1_PIN,
    REFERENCE_RESISTANCE,
    NOMINAL_RESISTANCE,
    NOMINAL_TEMPERATURE,
    B_VALUE
  );
}

const unsigned long extrusion_rate = 5;
static unsigned long extrusion_timer;
static unsigned int extrusion_progress = 0;
static unsigned long last_time = 0.0;


void draw_filament()
{
  for (size_t y = 57; y < 64; y++)
  {
    for (size_t x = 63; x < 65; x++)
    {
      if ((x + y + extrusion_progress) % 2 == 0 || y + extrusion_progress % 4 == 0)
      {
        u8g2.drawPixel(x, y);
      }
    }
  }
}

void draw_thermistor_temperature_readings()
{
  u8g2.setFont(u8g2_font_ncenB08_te);
  double celsius = upper_thermistor->readCelsius();
  t0_samples.add(celsius);
  char s[100];
  sprintf(s, "%d\xB0""C", (int)t0_samples.getAverage());
  u8g2.drawStr(74, 35, s);
  double celsius2 = lower_thermistor->readCelsius();
  t2_samples.add(celsius2);
  char s2[100];
  sprintf(s2, "%d\xB0""C", (int)t2_samples.getAverage());
  u8g2.drawStr(74, 48, s2);

  char s3[100];
  sprintf(s3, "%d", (int)heat_target[0]);
  u8g2.drawStr(103, 19, s3);
}

int loop_counter = 0;
int dir = 1;
float amount = 5.0f;

void loop(void) {
  if (millis() - last_time >= 20)
  {
    unsigned long delta = millis() - last_time;

    u8g2.firstPage();
    do {
      u8g2.drawXBMP(0, 0, _width, _height, _bits);
      u8g2.setFont(u8g2_font_ncenB08_tr);
      u8g2.drawStr(2,10,"OSE");
      u8g2.setFont(u8g2_font_5x7_tf);
      u8g2.drawStr(2,18,"Filament");
      u8g2.drawStr(2,26,"Extruder");
      u8g2.setFont(u8g2_font_4x6_tr);
      u8g2.drawStr(2,33,"v21.10");
      draw_filament();
      draw_thermistor_temperature_readings();

    } while ( u8g2.nextPage() );

    heat_velocity[0] = t0_samples.getElement(0) - t0_samples.getElement(99);
    heat_velocity[1] = t2_samples.getElement(0) - t2_samples.getElement(99);

    digitalWrite(40, upper_thermistor->readCelsius() < heat_target[0]);
    digitalWrite(42, lower_thermistor->readCelsius() < heat_target[1]);

    extrusion_timer += delta;
    while (extrusion_timer >= extrusion_rate)
    {
      extrusion_timer -= extrusion_rate;
      extrusion_progress++;
    }
    last_time = millis();
  }

  noInterrupts();
  if (value < 0)
  {
    value = 0;
  }
  else if (value != last) {
    Serial.print("Encoder Value: ");
    char s[100];
    sprintf(s, "%ld", value);
    Serial.println(s);
    heat_target[0] += dir * amount * value;
    heat_target[1] += dir * amount * value;
    value = 0;
    last = value;
  }
  interrupts();

  ClickEncoder::Button b = encoder->getButton();
  if (b != ClickEncoder::Open) {
    switch (b) {
      case ClickEncoder::Clicked:
        Serial.println("ClickEncoder::Clicked");
        break;
      case ClickEncoder::Pressed:
        Serial.println("ClickEncoder::Pressed");
        break;
      case ClickEncoder::DoubleClicked:
        Serial.println("ClickEncoder::DoubleClicked");
        dir = -dir;
        break;
    }
  }
}